% Histogram of the actual success bounds for the oblivious tampering pattern.

restoredefaultpath;
addpath('../include/');
addpath('../include/fc');
addpath('../include/alloc');

N = 1000;
values = zeros(1,N);
for i = 1:N
    [v, mv] = plot_demand([0.25 0.5 1], [3 2 1], 4096, -3);
    values(i) = v;
end

[pi, xi] = hist(values, 16);
pi = pi/sum(pi);
bar(xi, pi, 'hist');

dv = 1.96*std(values)/sqrt(N);
fprintf('Mean expected: %.5f, Mean simulated: %.5f - 95%% conf (%.5f, %.5f)\n', mv, mean(values), mean(values)-dv, mean(values)+dv);
