%% Generation of the QProfile sctructure.
% 
% Script for generating custom sets of reconstruction profiles

restoredefaultpath;
addpath('../include');
addpath('../include/alloc');

o = self_recovery_defaults();

% Select the training set which was used to generate the quantizers
% and the distortion models. Provided options include: bows, sipi, ucid
o.dm_dataset = 'bows';

% Example setup for 4 profiles, LSBS = 2, and only lambda changing
o.LSBS = 2;

% For each profile, select the type of blocks which were used
% to train the quantizers and the distortion models:
% 0 - all blocks
% 1 - low-texture blocks
% 2 - medium-texture blocks
% 3 - high-texture blocks
SA_profiles = [0 0 0 0];

% RLF symbol lenght, typically same as embedding capacity per block
% (exclusive of hash length and descriptor info)
base_symbol_length = 88;

% Quality levels for successive profiles
lambdas = [1 2 3 4];

% Guard levels
guard_levels = [1];

QProfiles = setup_qprofiles(o, SA_profiles, lambdas, base_symbol_length, guard_levels);
print_qprofiles(QProfiles);