function P = apply_allocation(xo)
%
% P = apply_allocation(xo)
%
% Apply the optimization solution to the 8x8 matrix:
%
% [8 6 5] -> [8 6 5 0 0 0 0 0
%             6 5 0 0 0 0 0 0
%             5 0 0 0 0 0 0 0
%             0 0 0 0 0 0 0 0
%             0 0 0 0 0 0 0 0
%             0 0 0 0 0 0 0 0
%             0 0 0 0 0 0 0 0
%             0 0 0 0 0 0 0 0]
%
    Aeq = [1 2 3 4 5 6 7 8 7 6 5 4 3 2 1];
    indices = zigzag(8);
    ptrs = cumsum(Aeq);

    P = zeros(8,8);
    for i = 1:length(xo);
        P(indices(ptrs(i)-Aeq(i)+1:ptrs(i))) = xo(i);
    end
end