function [bits_out] = c_rlf_decode(bits_in, block, blocks, error_map, key)
%
% bits_out = c_rlf_decode(bits_in, block, blocks, error_map, key)
%
% Implementation of the random linear fountain decoder. Uses Gaussian
% elimination for solving the problem.
%
% This version is a wrapper for the C++ RLF code written by Jarosław Białas.
% 
% Input Parameters:
%
%   - bits_in - input bitstream, vector of 0 and 1 (uint16)
%
%   - block   - symbol length
%
%   - blocks  - the number of original message symbols
%  
%   - error_map - the tampering map, vector of 0 and 1, 
%                 tampered as 1-s (uint8)
%
%   - key - integer, the seed for the PRNG
%
% Output:
% 
% bits_out - decoded bitstream, vector of 0 and 1
%
% ------------------------------------------------------------------------
%
% Copyright (C) Paweł Korus
% All rights reserved.
%
% Version: 2011.12.05
% Contact: Paweł Korus, pkorus@agh.edu.pl
%
% The author is with the Department of Telecommunications of AGH University
% of Science and Technology, Kraków, Poland.
%
% ------------------------------------------------------------------------
%
% Permission to use, copy, or modify this software and its documentation
% for educational and research purposes only and without fee is hereby
% granted, provided that this copyright notice and the original authors'
% names appear on all copies and supporting documentation. This program
% shall not be used, rewritten, or adapted as the basis of a commercial
% software or hardware product without first obtaining permission of the
% authors. The authors make no representations about the suitability of
% this software for any purpose. It is provided "as is" without express
% or implied warranty.
%----------------------------------------------------------------------
%
% The research leading to these results has received funding from the
% INDECT project funded by European Community's Seventh Framework Pro-
% -gramme (FP7 / 2007-2013) under grant agreement no.[218086].
%
