function [data, perc] = remove_outliers_bplot2(data, retain_rate)
% 
% data = remove_outliers_bplot(data, alpha)
%
% [q1 - alpha*(q3-q1); q3 + alpha*(q3-q1)]
%
% Input: 
%  - data - self-explanatory
%  - alpha - 
%
% Output:
%  - perc - amount of retained samples [0,1]

    q1 = quantile(data, 0.25);
    q3 = quantile(data, 0.75);

    nums = numel(data);
    for alpha = 1:0.01:6
        data_new = data(data >= (q1-alpha*(q3-q1)) & data <= (q3+alpha*(q3-q1)));
        perc = numel(data_new)/nums;
        if perc >= retain_rate
            break
        end
    end
    data = data_new;
    perc = numel(data_new)/nums;
end