function imgt = tamper_prior(imgw, t, QD)

    [H, W] = size(imgw);
    if ~exist('BLOCK', 'var'), BLOCK = 8; end

    % TAMPER SOME BLOCKS
    imgt = imgw;

    % Select random image frgmants that will be replaced with content from
    % another image
    
    % Determine the number of tampered blocks from the specified tampering
    % rate
    T = int32(W*H/BLOCK/BLOCK*t);
    r.gamma = double(T) / (W*H/BLOCK/BLOCK);
    
    % Generate a tampered image as a source for content tampering    
    imgs = imresize(imgw', size(imgw));
    imgs = imgs + uint8(randint(size(imgw,1),size(imgw,2),32));

    fprintf('Prioritized tampering pattern with rate %.4f\n', r.gamma);
    QD = QD(:);
    [tsv,ts] = sort(QD, 'descend');
    tsu = unique(tsv);
    for i = 1:length(tsu)
        temp = ts(tsv == tsu(i));
        ts(tsv == tsu(i)) = temp(randperm(length(temp)));
    end
    ts = ts(1:T);
    
    % Actual tampering
    for bx = 1:W/BLOCK
        for by = 1:H/BLOCK
            block_id = by + (bx-1)*H/BLOCK - 1 + 1;
            if numel(find(ts == block_id)) > 0
                B = imgs(1+(by-1)*BLOCK:(by)*BLOCK, 1+(bx-1)*BLOCK:(bx)*BLOCK);
                imgt(1+(by-1)*BLOCK:(by)*BLOCK, 1+(bx-1)*BLOCK:(bx)*BLOCK) = B;
            end
        end
    end

end